Loading...
Searching...
No Matches
pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT > Class Template Reference

`#include <pcl/features/organized_edge_detection.h>`

Inheritance diagram for pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >:

## Public Member Functions

| OrganizedEdgeFromNormals ()
| Constructor for OrganizedEdgeFromNormals.
| ~OrganizedEdgeFromNormals () override=default
| Destructor for OrganizedEdgeFromNormals.
void | compute (pcl::PointCloud< PointLT > &labels, std::vector< pcl::PointIndices > &label_indices) const
| Perform the 3D edge detection (edges from depth discontinuities and high curvature regions) and assign point indices for each edge label.
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input normals.
PointCloudNConstPtr | getInputNormals () const
| Get the input normals.
void | setHCCannyLowThreshold (const float th)
| Set the low threshold value for high curvature Canny edge detection.
float | getHCCannyLowThreshold () const
| Get the low threshold value for high curvature Canny edge detection.
void | setHCCannyHighThreshold (const float th)
| Set the high threshold value for high curvature Canny edge detection.
float | getHCCannyHighThreshold () const
| Get the high threshold value for high curvature Canny edge detection.
Public Member Functions inherited from pcl::OrganizedEdgeBase< PointT, PointLT >
| OrganizedEdgeBase ()
| Constructor for OrganizedEdgeBase.
| ~OrganizedEdgeBase () override=default
| Destructor for OrganizedEdgeBase.
void | compute (pcl::PointCloud< PointLT > &labels, std::vector< pcl::PointIndices > &label_indices) const
| Perform the 3D edge detection (edges from depth discontinuities).
void | setDepthDisconThreshold (const float th)
| Set the tolerance in meters for the relative difference in depth values between neighboring points.
float | getDepthDisconThreshold () const
| Get the tolerance in meters for the relative difference in depth values between neighboring points.
void | setMaxSearchNeighbors (const int max_dist)
| Set the max search distance for deciding occluding and occluded edges.
int | getMaxSearchNeighbors () const
| Get the max search distance for deciding occluding and occluded edges.
void | setEdgeType (int edge_types)
| Set the detecting edge types.
int | getEdgeType () const
| Get the detecting edge types.
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

void | extractEdges (pcl::PointCloud< PointLT > &labels) const
| Perform the 3D edge detection (edges from depth discontinuities and high curvature regions).
Protected Member Functions inherited from pcl::OrganizedEdgeBase< PointT, PointLT >
void | extractEdges (pcl::PointCloud< PointLT > &labels) const
| Perform the 3D edge detection (edges from depth discontinuities) and assign point indices for each edge label.
void | assignLabelIndices (pcl::PointCloud< PointLT > &labels, std::vector< pcl::PointIndices > &label_indices) const
| Assign point indices for each edge label.
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

PointCloudNConstPtr | normals_
| A pointer to the input normals.
float | th_hc_canny_low_ {0.4f}
| The low threshold value for high curvature Canny edge detection (default: 0.4).
float | th_hc_canny_high_ {1.1f}
| The high threshold value for high curvature Canny edge detection (default: 1.1).
Protected Attributes inherited from pcl::OrganizedEdgeBase< PointT, PointLT >
float | th_depth_discon_ {0.02f}
| The tolerance in meters for the relative difference in depth values between neighboring points (The default value is set for .02 meters and is adapted with respect to depth value linearly.
int | max_search_neighbors_ {50}
| The max search distance for deciding occluding and occluded edges.
int | detecting_edge_types_
| The bit encoded value that represents edge types to detect.
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Additional Inherited Members

Public Types inherited from pcl::OrganizedEdgeBase< PointT, PointLT >
enum | { EDGELABEL_NAN_BOUNDARY =1 , EDGELABEL_OCCLUDING =2 , EDGELABEL_OCCLUDED =4 , EDGELABEL_HIGH_CURVATURE =8 , EDGELABEL_RGB_CANNY =16 }
using | Ptr = shared_ptr<OrganizedEdgeBase<PointT, PointLT> >
using | ConstPtr = shared_ptr<const OrganizedEdgeBase<PointT, PointLT> >
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr
Static Public Attributes inherited from pcl::OrganizedEdgeBase< PointT, PointLT >
static const int | num_of_edgetype_ = 5

## Detailed Description

template<typename PointT, typename PointNT, typename PointLT>
class pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >

Definition at line 262 of file organized_edge_detection.h.

## Constructor & Destructor Documentation

## OrganizedEdgeFromNormals()

template<typename PointT, typename PointNT, typename PointLT>

pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::OrganizedEdgeFromNormals | ( |  | ) |

inline

Constructor for OrganizedEdgeFromNormals.

Definition at line 288 of file organized_edge_detection.h.

References pcl::OrganizedEdgeBase< PointT, PointLT >::EDGELABEL_HIGH_CURVATURE, pcl::OrganizedEdgeBase< PointT, PointLT >::EDGELABEL_NAN_BOUNDARY, pcl::OrganizedEdgeBase< PointT, PointLT >::EDGELABEL_OCCLUDED, pcl::OrganizedEdgeBase< PointT, PointLT >::EDGELABEL_OCCLUDING, normals_, pcl::OrganizedEdgeBase< PointT, PointLT >::OrganizedEdgeBase(), and pcl::OrganizedEdgeBase< PointT, PointLT >::setEdgeType().

Referenced by pcl::OrganizedEdgeFromRGBNormals< PointT, PointNT, PointLT >::OrganizedEdgeFromRGBNormals().

## ~OrganizedEdgeFromNormals()

template<typename PointT, typename PointNT, typename PointLT>

pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::~OrganizedEdgeFromNormals | ( |  | ) |

override default

Destructor for OrganizedEdgeFromNormals.

## Member Function Documentation

## compute()

template<typename PointT, typename PointNT, typename PointLT>

void pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::compute | ( | pcl::PointCloud< PointLT > & | labels,
|  | std::vector< pcl::PointIndices > & | label_indices ) const

Perform the 3D edge detection (edges from depth discontinuities and high curvature regions) and assign point indices for each edge label.

Parameters

  [out] | labels | a PointCloud of edge labels
  [out] | label_indices | a vector of PointIndices corresponding to each edge label

Definition at line 274 of file organized_edge_detection.hpp.

References pcl::OrganizedEdgeBase< PointT, PointLT >::assignLabelIndices(), pcl::OrganizedEdgeBase< PointT, PointLT >::extractEdges(), extractEdges(), pcl::PointCloud< PointT >::height, pcl::PCLBase< PointT >::input_, pcl::Label::label, pcl::PointCloud< PointT >::resize(), and pcl::PointCloud< PointT >::width.

## extractEdges()

template<typename PointT, typename PointNT, typename PointLT>

void pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::extractEdges | ( | pcl::PointCloud< PointLT > & | labels | ) | const

protected

Perform the 3D edge detection (edges from depth discontinuities and high curvature regions).

Parameters

  [out] | labels | a PointCloud of edge labels

Definition at line 290 of file organized_edge_detection.hpp.

References pcl::Edge< PointInT, PointOutT >::canny(), pcl::OrganizedEdgeBase< PointT, PointLT >::detecting_edge_types_, pcl::OrganizedEdgeBase< PointT, PointLT >::EDGELABEL_HIGH_CURVATURE, pcl::PointCloud< PointT >::height, normals_, pcl::PointCloud< PointT >::resize(), pcl::Edge< PointInT, PointOutT >::setHysteresisThresholdHigh(), pcl::Edge< PointInT, PointOutT >::setHysteresisThresholdLow(), th_hc_canny_high_, th_hc_canny_low_, and pcl::PointCloud< PointT >::width.

Referenced by compute(), and pcl::OrganizedEdgeFromRGBNormals< PointT, PointNT, PointLT >::compute().

## getHCCannyHighThreshold()

template<typename PointT, typename PointNT, typename PointLT>

float pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::getHCCannyHighThreshold | ( |  | ) | const

inline

Get the high threshold value for high curvature Canny edge detection.

Definition at line 345 of file organized_edge_detection.h.

References th_hc_canny_high_.

## getHCCannyLowThreshold()

template<typename PointT, typename PointNT, typename PointLT>

float pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::getHCCannyLowThreshold | ( |  | ) | const

inline

Get the low threshold value for high curvature Canny edge detection.

Definition at line 331 of file organized_edge_detection.h.

References th_hc_canny_low_.

## getInputNormals()

template<typename PointT, typename PointNT, typename PointLT>

PointCloudNConstPtr pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::getInputNormals | ( |  | ) | const

inline

Get the input normals.

Definition at line 317 of file organized_edge_detection.h.

References normals_.

## setHCCannyHighThreshold()

template<typename PointT, typename PointNT, typename PointLT>

void pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::setHCCannyHighThreshold | ( | const float | th | ) |

inline

Set the high threshold value for high curvature Canny edge detection.

Definition at line 338 of file organized_edge_detection.h.

References th_hc_canny_high_.

## setHCCannyLowThreshold()

template<typename PointT, typename PointNT, typename PointLT>

void pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::setHCCannyLowThreshold | ( | const float | th | ) |

inline

Set the low threshold value for high curvature Canny edge detection.

Definition at line 324 of file organized_edge_detection.h.

References th_hc_canny_low_.

## setInputNormals()

template<typename PointT, typename PointNT, typename PointLT>

void pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::setInputNormals | ( | const PointCloudNConstPtr & | normals | ) |

inline

Provide a pointer to the input normals.

Parameters

  [in] | normals | the input normal cloud

Definition at line 310 of file organized_edge_detection.h.

References normals_.

## Member Data Documentation

## normals_

template<typename PointT, typename PointNT, typename PointLT>

PointCloudNConstPtr pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::normals_

protected

A pointer to the input normals.

Definition at line 358 of file organized_edge_detection.h.

Referenced by extractEdges(), getInputNormals(), OrganizedEdgeFromNormals(), and setInputNormals().

## th_hc_canny_high_

template<typename PointT, typename PointNT, typename PointLT>

float pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::th_hc_canny_high_ {1.1f}

protected

The high threshold value for high curvature Canny edge detection (default: 1.1).

Definition at line 364 of file organized_edge_detection.h.

Referenced by extractEdges(), getHCCannyHighThreshold(), and setHCCannyHighThreshold().

## th_hc_canny_low_

template<typename PointT, typename PointNT, typename PointLT>

float pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::th_hc_canny_low_ {0.4f}

protected

The low threshold value for high curvature Canny edge detection (default: 0.4).

Definition at line 361 of file organized_edge_detection.h.

Referenced by extractEdges(), getHCCannyLowThreshold(), and setHCCannyLowThreshold().

The documentation for this class was generated from the following files:

- pcl/features/organized_edge_detection.h
- pcl/features/impl/organized_edge_detection.hpp